#include "rtos.h"
/* Provide Declarations */
//#include <stdarg.h>
//#include <setjmp.h>
/* get a declaration for alloca */
#if defined(__CYGWIN__) || defined(__MINGW32__)
#define  alloca(x) __builtin_alloca((x))
#define _alloca(x) __builtin_alloca((x))
#elif defined(__APPLE__)
extern void *__builtin_alloca(unsigned long);
#define alloca(x) __builtin_alloca(x)
#define longjmp _longjmp
#define setjmp _setjmp
#elif defined(__sun__)
#if defined(__sparcv9)
extern void *__builtin_alloca(unsigned long);
#else
extern void *__builtin_alloca(unsigned int);
#endif
#define alloca(x) __builtin_alloca(x)
#elif defined(__FreeBSD__) || defined(__NetBSD__) || defined(__OpenBSD__) || defined(__DragonFly__) || defined(__arm__)
#define alloca(x) __builtin_alloca(x)
#elif defined(_MSC_VER)
#define inline _inline
#define alloca(x) _alloca(x)
#else
//#include <alloca.h>
#endif

#ifndef __GNUC__  /* Can only support "linkonce" vars with GCC */
#define __attribute__(X)
#endif

#if defined(__GNUC__) && defined(__APPLE_CC__)
#define __EXTERNAL_WEAK__ __attribute__((weak_import))
#elif defined(__GNUC__)
#define __EXTERNAL_WEAK__ __attribute__((weak))
#else
#define __EXTERNAL_WEAK__
#endif

#if defined(__GNUC__) && defined(__APPLE_CC__)
#define __ATTRIBUTE_WEAK__
#elif defined(__GNUC__)
#define __ATTRIBUTE_WEAK__ __attribute__((weak))
#else
#define __ATTRIBUTE_WEAK__
#endif

#if defined(__GNUC__)
#define __HIDDEN__ __attribute__((visibility("hidden")))
#endif

#ifdef __GNUC__
#define LLVM_NAN(NanStr)   __builtin_nan(NanStr)   /* Double */
#define LLVM_NANF(NanStr)  __builtin_nanf(NanStr)  /* Float */
#define LLVM_NANS(NanStr)  __builtin_nans(NanStr)  /* Double */
#define LLVM_NANSF(NanStr) __builtin_nansf(NanStr) /* Float */
#define LLVM_INF           __builtin_inf()         /* Double */
#define LLVM_INFF          __builtin_inff()        /* Float */
#define LLVM_PREFETCH(addr,rw,locality) __builtin_prefetch(addr,rw,locality)
#define __ATTRIBUTE_CTOR__ __attribute__((constructor))
#define __ATTRIBUTE_DTOR__ __attribute__((destructor))
#define LLVM_ASM           __asm__
#else
#define LLVM_NAN(NanStr)   ((double)0.0)           /* Double */
#define LLVM_NANF(NanStr)  0.0F                    /* Float */
#define LLVM_NANS(NanStr)  ((double)0.0)           /* Double */
#define LLVM_NANSF(NanStr) 0.0F                    /* Float */
#define LLVM_INF           ((double)0.0)           /* Double */
#define LLVM_INFF          0.0F                    /* Float */
#define LLVM_PREFETCH(addr,rw,locality)            /* PREFETCH */
#define __ATTRIBUTE_CTOR__
#define __ATTRIBUTE_DTOR__
#define LLVM_ASM(X)
#endif

#if __GNUC__ < 4 /* Old GCC's, or compilers not GCC */ 
#define __builtin_stack_save() 0   /* not implemented */
#define __builtin_stack_restore(X) /* noop */
#endif

#if __GNUC__ && __LP64__ /* 128-bit integer types */
typedef int __attribute__((mode(TI))) llvmInt128;
typedef unsigned __attribute__((mode(TI))) llvmUInt128;
#endif

#define CODE_FOR_MAIN() /* Any target-specific code for main()*/

#ifndef __cplusplus
typedef unsigned char bool;
#endif


/* Support for floating point constants */
typedef unsigned long long ConstantDoubleTy;
typedef unsigned int        ConstantFloatTy;
typedef struct { unsigned long long f1; unsigned short f2; unsigned short pad[3]; } ConstantFP80Ty;
typedef struct { unsigned long long f1; unsigned long long f2; } ConstantFP128Ty;


/* Global Declarations */
/* Helper union for bitcasts */
typedef union {
  unsigned int Int32;
  unsigned long long Int64;
  float Float;
  double Double;
} llvmBitCastUnion;
/* Structure forward decls */
struct l_unnamed0;
struct l_unnamed1;
struct l_unnamed2;
struct l_unnamed3;
struct l_unnamed4;
struct l_unnamed5;

/* Typedefs */
typedef struct l_unnamed0 l_unnamed0;
typedef struct l_unnamed1 l_unnamed1;
typedef struct l_unnamed2 l_unnamed2;
typedef struct l_unnamed3 l_unnamed3;
typedef struct l_unnamed4 l_unnamed4;
typedef struct l_unnamed5 l_unnamed5;

/* Structure contents */
struct l_unnamed0 { unsigned char array[9]; };

struct l_unnamed1 { unsigned char array[55]; };

struct l_unnamed2 { unsigned int array[257]; };

struct l_unnamed3 { unsigned short array[257]; };

struct l_unnamed4 { unsigned char array[16]; };

struct l_unnamed5 { unsigned char array[50]; };


/* External Global Variable Declarations */

/* Function Declarations */
double fmod(double, double);
float fmodf(float, float);
long double fmodl(long double, long double);
unsigned int main(void);
void abort(void);


/* Global Variable Declarations */
static unsigned int maxbits;
static unsigned int maxmaxcode;
static unsigned int hsize;
static unsigned int free_ent;
static unsigned int exit_stat;
static unsigned int block_compress;
static unsigned int clear_flg;
static unsigned int ratio;
static unsigned int checkpoint;
static unsigned int InCnt;
static unsigned int apsim_InCnt;
static struct l_unnamed5 orig_text_buffer;
static unsigned char *InBuff;
static struct l_unnamed1 comp_text_buffer;
static unsigned char *OutBuff;
static unsigned int in_count;
static unsigned int out_count;
static unsigned int offset;
static unsigned int bytes_out;
static unsigned int n_bits;
static unsigned int maxcode;
static struct l_unnamed2 htab;
static struct l_unnamed3 codetab;
static struct l_unnamed0 lmask;
static struct l_unnamed0 rmask;
static struct l_unnamed4 buf;


/* Global Variable Definitions and Initialization */
static unsigned int maxbits = 16u;
static unsigned int maxmaxcode = 65536u;
static unsigned int hsize = 257u;
static unsigned int free_ent;
static unsigned int exit_stat;
static unsigned int block_compress = 128u;
static unsigned int clear_flg;
static unsigned int ratio;
static unsigned int checkpoint = 10000u;
static unsigned int InCnt;
static unsigned int apsim_InCnt;
static struct l_unnamed5 orig_text_buffer;
static unsigned char *InBuff;
static struct l_unnamed1 comp_text_buffer;
static unsigned char *OutBuff;
static unsigned int in_count = 1u;
static unsigned int out_count;
static unsigned int offset;
static unsigned int bytes_out;
static unsigned int n_bits;
static unsigned int maxcode;
static struct l_unnamed2 htab;
static struct l_unnamed3 codetab;
static struct l_unnamed0 lmask = { "\xFF\xFE\xFC\xF8\xF0\xE0\xC0\x80" };
static struct l_unnamed0 rmask = { { ((unsigned char )0), ((unsigned char )1), ((unsigned char )3), ((unsigned char )7), ((unsigned char )15), ((unsigned char )31), ((unsigned char )63), ((unsigned char )127), ((unsigned char )-1) } };
static struct l_unnamed4 buf;


/* Function Bodies */
static inline int llvm_fcmp_ord(double X, double Y) { return X == X && Y == Y; }
static inline int llvm_fcmp_uno(double X, double Y) { return X != X || Y != Y; }
static inline int llvm_fcmp_ueq(double X, double Y) { return X == Y || llvm_fcmp_uno(X, Y); }
static inline int llvm_fcmp_une(double X, double Y) { return X != Y; }
static inline int llvm_fcmp_ult(double X, double Y) { return X <  Y || llvm_fcmp_uno(X, Y); }
static inline int llvm_fcmp_ugt(double X, double Y) { return X >  Y || llvm_fcmp_uno(X, Y); }
static inline int llvm_fcmp_ule(double X, double Y) { return X <= Y || llvm_fcmp_uno(X, Y); }
static inline int llvm_fcmp_uge(double X, double Y) { return X >= Y || llvm_fcmp_uno(X, Y); }
static inline int llvm_fcmp_oeq(double X, double Y) { return X == Y ; }
static inline int llvm_fcmp_one(double X, double Y) { return X != Y && llvm_fcmp_ord(X, Y); }
static inline int llvm_fcmp_olt(double X, double Y) { return X <  Y ; }
static inline int llvm_fcmp_ogt(double X, double Y) { return X >  Y ; }
static inline int llvm_fcmp_ole(double X, double Y) { return X <= Y ; }
static inline int llvm_fcmp_oge(double X, double Y) { return X >= Y ; }

unsigned int compress(void) {
  unsigned char *llvm_cbe_buf_addr_2e_i72;    /* Address-exposed local */
  unsigned int llvm_cbe_n_addr_2e_i73;    /* Address-exposed local */
  unsigned int llvm_cbe_i_2e_i74;    /* Address-exposed local */
  unsigned char *llvm_cbe_buf_addr_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_n_addr_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_i_2e_i67;    /* Address-exposed local */
  unsigned char llvm_cbe_c_addr_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_code_addr_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_r_off_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_bits_2e_i;    /* Address-exposed local */
  unsigned char *llvm_cbe_bp_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_hsize_addr_2e_i34;    /* Address-exposed local */
  unsigned int *llvm_cbe_htab_p_2e_i35;    /* Address-exposed local */
  unsigned int llvm_cbe_i_2e_i36;    /* Address-exposed local */
  unsigned int llvm_cbe_m1_2e_i37;    /* Address-exposed local */
  unsigned int llvm_cbe_rat_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_retval_2e_i14;    /* Address-exposed local */
  unsigned int llvm_cbe_tmp__1;    /* Address-exposed local */
  unsigned int llvm_cbe_hsize_addr_2e_i;    /* Address-exposed local */
  unsigned int *llvm_cbe_htab_p_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_i_2e_i8;    /* Address-exposed local */
  unsigned int llvm_cbe_m1_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_retval_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_tmp__2;    /* Address-exposed local */
  unsigned int llvm_cbe_iftmp_2e_5_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_fcode_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_i_2e_i1;    /* Address-exposed local */
  unsigned int llvm_cbe_c_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_ent_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_disp_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_hsize_reg_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_hshift_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_apsim_bound111_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_seed_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_i_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_tabort_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_retval;    /* Address-exposed local */
  unsigned int llvm_cbe_tmp__3;    /* Address-exposed local */
  unsigned int llvm_cbe_count;    /* Address-exposed local */
  unsigned int llvm_cbe_alloca_20_point;
  unsigned int llvm_cbe_tmp__4;
  unsigned int llvm_cbe_tmp__5;
  unsigned int llvm_cbe_tmp__6;
  unsigned int llvm_cbe_tmp__7;
  unsigned int llvm_cbe_tmp__8;
  unsigned int llvm_cbe_tmp__9;
  unsigned int llvm_cbe_tmp__10;
  unsigned int llvm_cbe_tmp__11;
  unsigned int llvm_cbe_tmp__12;
  unsigned int llvm_cbe_tmp__13;
  unsigned int llvm_cbe_tmp__14;
  unsigned int llvm_cbe_tmp__15;
  unsigned int llvm_cbe_tmp__16;
  unsigned int llvm_cbe_tmp__17;
  unsigned char *llvm_cbe_tmp__18;
  unsigned char llvm_cbe_tmp__19;
  unsigned int llvm_cbe_tmp__20;
  unsigned int llvm_cbe_retval7_2e_i;
  unsigned int llvm_cbe_tmp__21;
  unsigned int llvm_cbe_tmp__22;
  unsigned int llvm_cbe_tmp__23;
  unsigned int llvm_cbe_tmp__24;
  unsigned int llvm_cbe_tmp__25;
  unsigned int llvm_cbe_tmp__26;
  unsigned int llvm_cbe_tmp__27;
  unsigned int llvm_cbe_tmp__28;
  unsigned int *llvm_cbe_tmp__29;
  unsigned int llvm_cbe_tmp__30;
  unsigned int *llvm_cbe_tmp__31;
  unsigned int llvm_cbe_tmp__32;
  unsigned int *llvm_cbe_tmp__33;
  unsigned int llvm_cbe_tmp__34;
  unsigned int *llvm_cbe_tmp__35;
  unsigned int llvm_cbe_tmp__36;
  unsigned int *llvm_cbe_tmp__37;
  unsigned int llvm_cbe_tmp__38;
  unsigned int *llvm_cbe_tmp__39;
  unsigned int llvm_cbe_tmp__40;
  unsigned int *llvm_cbe_tmp__41;
  unsigned int llvm_cbe_tmp__42;
  unsigned int *llvm_cbe_tmp__43;
  unsigned int llvm_cbe_tmp__44;
  unsigned int *llvm_cbe_tmp__45;
  unsigned int llvm_cbe_tmp__46;
  unsigned int *llvm_cbe_tmp__47;
  unsigned int llvm_cbe_tmp__48;
  unsigned int *llvm_cbe_tmp__49;
  unsigned int llvm_cbe_tmp__50;
  unsigned int *llvm_cbe_tmp__51;
  unsigned int llvm_cbe_tmp__52;
  unsigned int *llvm_cbe_tmp__53;
  unsigned int llvm_cbe_tmp__54;
  unsigned int *llvm_cbe_tmp__55;
  unsigned int llvm_cbe_tmp__56;
  unsigned int *llvm_cbe_tmp__57;
  unsigned int llvm_cbe_tmp__58;
  unsigned int *llvm_cbe_tmp__59;
  unsigned int llvm_cbe_tmp__60;
  unsigned int *llvm_cbe_tmp__61;
  unsigned int llvm_cbe_tmp__62;
  unsigned int llvm_cbe_tmp__63;
  unsigned int llvm_cbe_tmp__64;
  unsigned int *llvm_cbe_tmp__65;
  unsigned int *llvm_cbe_tmp__66;
  unsigned int llvm_cbe_tmp__67;
  unsigned int llvm_cbe_tmp__68;
  unsigned int llvm_cbe_tmp__69;
  unsigned int llvm_cbe_tmp__70;
  unsigned int llvm_cbe_tmp__71;
  unsigned int llvm_cbe_tmp__72;
  unsigned char *llvm_cbe_tmp__73;
  unsigned char llvm_cbe_tmp__74;
  unsigned int llvm_cbe_tmp__75;
  unsigned int llvm_cbe_retval7_2e_i23;
  unsigned int llvm_cbe_tmp__76;
  unsigned int llvm_cbe_tmp__77;
  unsigned int llvm_cbe_tmp__78;
  unsigned int llvm_cbe_tmp__79;
  unsigned int llvm_cbe_tmp__80;
  unsigned int llvm_cbe_tmp__81;
  unsigned int llvm_cbe_tmp__82;
  unsigned int llvm_cbe_tmp__83;
  unsigned int llvm_cbe_tmp__84;
  unsigned int llvm_cbe_tmp__85;
  unsigned int llvm_cbe_tmp__86;
  unsigned short llvm_cbe_tmp__87;
  unsigned int llvm_cbe_tmp__88;
  unsigned int llvm_cbe_tmp__89;
  unsigned int llvm_cbe_tmp__90;
  unsigned int llvm_cbe_tmp__91;
  unsigned int llvm_cbe_tmp__92;
  unsigned int llvm_cbe_tmp__93;
  unsigned int llvm_cbe_tmp__94;
  unsigned int llvm_cbe_tmp__95;
  unsigned int llvm_cbe_tmp__96;
  unsigned int llvm_cbe_tmp__97;
  unsigned int llvm_cbe_tmp__98;
  unsigned int llvm_cbe_tmp__99;
  unsigned int llvm_cbe_tmp__100;
  unsigned short llvm_cbe_tmp__101;
  unsigned int llvm_cbe_tmp__102;
  unsigned int llvm_cbe_tmp__103;
  unsigned int llvm_cbe_tmp__104;
  unsigned int llvm_cbe_tmp__105;
  unsigned int llvm_cbe_tmp__106;
  unsigned int llvm_cbe_tmp__107;
  unsigned int llvm_cbe_tmp__108;
  unsigned int llvm_cbe_tmp__109;
  unsigned int llvm_cbe_tmp__110;
  unsigned int llvm_cbe_tmp__111;
  unsigned int llvm_cbe_tmp__112;
  unsigned int llvm_cbe_tmp__113;
  unsigned int llvm_cbe_tmp__114;
  unsigned int llvm_cbe_tmp__115;
  unsigned int llvm_cbe_tmp__116;
  unsigned int llvm_cbe_tmp__117;
  unsigned int llvm_cbe_tmp__118;
  unsigned int llvm_cbe_tmp__119;
  unsigned int llvm_cbe_tmp__120;
  unsigned int llvm_cbe_tmp__121;
  unsigned int llvm_cbe_tmp__122;
  unsigned int llvm_cbe_tmp__123;
  unsigned int llvm_cbe_tmp__124;
  unsigned int llvm_cbe_tmp__125;
  unsigned int llvm_cbe_tmp__126;
  unsigned int llvm_cbe_tmp__127;
  unsigned int llvm_cbe_tmp__128;
  unsigned int llvm_cbe_tmp__129;
  unsigned int llvm_cbe_tmp__130;
  unsigned int *llvm_cbe_tmp__131;
  unsigned int llvm_cbe_tmp__132;
  unsigned int *llvm_cbe_tmp__133;
  unsigned int llvm_cbe_tmp__134;
  unsigned int *llvm_cbe_tmp__135;
  unsigned int llvm_cbe_tmp__136;
  unsigned int *llvm_cbe_tmp__137;
  unsigned int llvm_cbe_tmp__138;
  unsigned int *llvm_cbe_tmp__139;
  unsigned int llvm_cbe_tmp__140;
  unsigned int *llvm_cbe_tmp__141;
  unsigned int llvm_cbe_tmp__142;
  unsigned int *llvm_cbe_tmp__143;
  unsigned int llvm_cbe_tmp__144;
  unsigned int *llvm_cbe_tmp__145;
  unsigned int llvm_cbe_tmp__146;
  unsigned int *llvm_cbe_tmp__147;
  unsigned int llvm_cbe_tmp__148;
  unsigned int *llvm_cbe_tmp__149;
  unsigned int llvm_cbe_tmp__150;
  unsigned int *llvm_cbe_tmp__151;
  unsigned int llvm_cbe_tmp__152;
  unsigned int *llvm_cbe_tmp__153;
  unsigned int llvm_cbe_tmp__154;
  unsigned int *llvm_cbe_tmp__155;
  unsigned int llvm_cbe_tmp__156;
  unsigned int *llvm_cbe_tmp__157;
  unsigned int llvm_cbe_tmp__158;
  unsigned int *llvm_cbe_tmp__159;
  unsigned int llvm_cbe_tmp__160;
  unsigned int *llvm_cbe_tmp__161;
  unsigned int llvm_cbe_tmp__162;
  unsigned int *llvm_cbe_tmp__163;
  unsigned int llvm_cbe_tmp__164;
  unsigned int llvm_cbe_tmp__165;
  unsigned int llvm_cbe_tmp__166;
  unsigned int *llvm_cbe_tmp__167;
  unsigned int *llvm_cbe_tmp__168;
  unsigned int llvm_cbe_tmp__169;
  unsigned int llvm_cbe_tmp__170;
  unsigned int llvm_cbe_tmp__171;
  unsigned int llvm_cbe_tmp__172;
  unsigned int llvm_cbe_tmp__173;
  unsigned int llvm_cbe_tmp__174;
  unsigned int llvm_cbe_tmp__175;
  unsigned char *llvm_cbe_tmp__176;
  unsigned int llvm_cbe_tmp__177;
  unsigned char *llvm_cbe_tmp__178;
  unsigned char llvm_cbe_tmp__179;
  unsigned int llvm_cbe_tmp__180;
  unsigned char llvm_cbe_tmp__181;
  unsigned int llvm_cbe_tmp__182;
  unsigned int llvm_cbe_tmp__183;
  unsigned int llvm_cbe_tmp__184;
  unsigned char llvm_cbe_tmp__185;
  unsigned char *llvm_cbe_tmp__186;
  unsigned char *llvm_cbe_tmp__187;
  unsigned int llvm_cbe_tmp__188;
  unsigned int llvm_cbe_tmp__189;
  unsigned int llvm_cbe_tmp__190;
  unsigned int llvm_cbe_tmp__191;
  unsigned int llvm_cbe_tmp__192;
  unsigned int llvm_cbe_tmp__193;
  unsigned char *llvm_cbe_tmp__194;
  unsigned char *llvm_cbe_tmp__195;
  unsigned int llvm_cbe_tmp__196;
  unsigned int llvm_cbe_tmp__197;
  unsigned int llvm_cbe_tmp__198;
  unsigned int llvm_cbe_tmp__199;
  unsigned char *llvm_cbe_tmp__200;
  unsigned int llvm_cbe_tmp__201;
  unsigned int llvm_cbe_tmp__202;
  unsigned int llvm_cbe_tmp__203;
  unsigned int llvm_cbe_tmp__204;
  unsigned int llvm_cbe_tmp__205;
  unsigned int llvm_cbe_tmp__206;
  unsigned int llvm_cbe_tmp__207;
  unsigned char *llvm_cbe_tmp__208;
  unsigned char llvm_cbe_tmp__209;
  unsigned char *llvm_cbe_tmp__210;
  unsigned char *llvm_cbe_tmp__211;
  unsigned char llvm_cbe_tmp__212;
  unsigned int llvm_cbe_tmp__213;
  unsigned int llvm_cbe_tmp__214;
  unsigned char *llvm_cbe_tmp__215;
  unsigned int llvm_cbe_tmp__216;
  unsigned int llvm_cbe_tmp__217;
  unsigned int llvm_cbe_tmp__218;
  unsigned int llvm_cbe_tmp__219;
  unsigned int llvm_cbe_tmp__220;
  unsigned char *llvm_cbe_tmp__221;
  unsigned char *llvm_cbe_tmp__222;
  unsigned int llvm_cbe_tmp__223;
  unsigned char llvm_cbe_tmp__224;
  unsigned int llvm_cbe_tmp__225;
  unsigned int llvm_cbe_tmp__226;
  unsigned int llvm_cbe_tmp__227;
  unsigned int llvm_cbe_tmp__228;
  unsigned int llvm_cbe_tmp__229;
  unsigned int llvm_cbe_tmp__230;
  unsigned int llvm_cbe_tmp__231;
  unsigned int llvm_cbe_tmp__232;
  unsigned int llvm_cbe_tmp__233;
  unsigned int llvm_cbe_tmp__234;
  unsigned int llvm_cbe_tmp__235;
  unsigned int llvm_cbe_tmp__236;
  unsigned int llvm_cbe_tmp__237;
  unsigned int llvm_cbe_tmp__238;
  unsigned int llvm_cbe_tmp__239;
  unsigned char *llvm_cbe_tmp__240;
  unsigned char *llvm_cbe_tmp__241;
  unsigned int llvm_cbe_tmp__242;
  unsigned char llvm_cbe_tmp__243;
  unsigned int llvm_cbe_tmp__244;
  unsigned int llvm_cbe_tmp__245;
  unsigned int llvm_cbe_tmp__246;
  unsigned int llvm_cbe_tmp__247;
  unsigned int llvm_cbe_tmp__248;
  unsigned int llvm_cbe_tmp__249;
  unsigned int llvm_cbe_tmp__250;
  unsigned int llvm_cbe_tmp__251;
  unsigned int llvm_cbe_tmp__252;
  unsigned int llvm_cbe_tmp__253;
  unsigned int llvm_cbe_retval1;

  CODE_FOR_MAIN();
  llvm_cbe_alloca_20_point = ((unsigned int )0u);
  *(&llvm_cbe_count) = 50u;
  *(&llvm_cbe_seed_2e_i) = 1u;
  *(&llvm_cbe_i_2e_i) = 0u;
  goto llvm_cbe_bb1_2e_i;

  do {     /* Syntactic loop 'bb1.i' to make GCC happy */
llvm_cbe_bb1_2e_i:
  llvm_cbe_tmp__9 = *(&llvm_cbe_i_2e_i);
  if ((((signed int )llvm_cbe_tmp__9) <= ((signed int )49u))) {
    goto llvm_cbe_bb_2e_i;
  } else {
    goto llvm_cbe_initbuffer_2e_exit;
  }

llvm_cbe_bb_2e_i:
  llvm_cbe_tmp__4 = *(&llvm_cbe_i_2e_i);
  *(&llvm_cbe_tabort_2e_i) = llvm_cbe_tmp__4;
  llvm_cbe_tmp__5 = *(&llvm_cbe_seed_2e_i);
  *(&llvm_cbe_seed_2e_i) = (((signed int )(((signed int )(((unsigned int )(((unsigned int )(((unsigned int )(((unsigned int )llvm_cbe_tmp__5) * ((unsigned int )133u))))) + ((unsigned int )81u))))) % ((signed int )8095u))));
  llvm_cbe_tmp__6 = *(&llvm_cbe_i_2e_i);
  llvm_cbe_tmp__7 = *(&llvm_cbe_seed_2e_i);
  *((&orig_text_buffer.array[((signed int )llvm_cbe_tmp__6)])) = (((unsigned char )(((signed int )(((signed int )llvm_cbe_tmp__7) % ((signed int )256u))))));
  llvm_cbe_tmp__8 = *(&llvm_cbe_i_2e_i);
  *(&llvm_cbe_i_2e_i) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__8) + ((unsigned int )1u))));
  goto llvm_cbe_bb1_2e_i;

  } while (1); /* end of syntactic loop 'bb1.i' */
llvm_cbe_initbuffer_2e_exit:
  *(&maxbits) = 16u;
  llvm_cbe_tmp__10 = *(&maxbits);
  *(&maxmaxcode) = (1u << llvm_cbe_tmp__10);
  llvm_cbe_tmp__11 = *(&llvm_cbe_count);
  *(&InCnt) = llvm_cbe_tmp__11;
  *(&apsim_InCnt) = 53u;
  *(&InBuff) = ((&orig_text_buffer.array[((signed int )0u)]));
  *(&OutBuff) = ((&comp_text_buffer.array[((signed int )0u)]));
  *(&llvm_cbe_i_2e_i1) = 0u;
  *(&offset) = 0u;
  *(&bytes_out) = 3u;
  *(&out_count) = 0u;
  *(&clear_flg) = 0u;
  *(&ratio) = 0u;
  *(&in_count) = 1u;
  *(&checkpoint) = 10000u;
  *(&n_bits) = 9u;
  llvm_cbe_tmp__12 = *(&n_bits);
  *(&maxcode) = (((unsigned int )(((unsigned int )(1u << llvm_cbe_tmp__12)) - ((unsigned int )1u))));
  llvm_cbe_tmp__13 = *(&block_compress);
  if ((llvm_cbe_tmp__13 != 0u)) {
    goto llvm_cbe_bb_2e_i2;
  } else {
    goto llvm_cbe_bb1_2e_i3;
  }

llvm_cbe_bb_2e_i2:
  *(&llvm_cbe_iftmp_2e_5_2e_i) = 257u;
  goto llvm_cbe_bb2_2e_i;

llvm_cbe_bb1_2e_i3:
  *(&llvm_cbe_iftmp_2e_5_2e_i) = 256u;
  goto llvm_cbe_bb2_2e_i;

llvm_cbe_bb2_2e_i:
  llvm_cbe_tmp__14 = *(&llvm_cbe_iftmp_2e_5_2e_i);
  *(&free_ent) = llvm_cbe_tmp__14;
  llvm_cbe_tmp__15 = *(&InCnt);
  if ((((signed int )llvm_cbe_tmp__15) <= ((signed int )0u))) {
    goto llvm_cbe_bb5_2e_i6;
  } else {
    goto llvm_cbe_bb_2e_i4;
  }

llvm_cbe_bb_2e_i4:
  llvm_cbe_tmp__16 = *(&apsim_InCnt);
  *(&apsim_InCnt) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__16) - ((unsigned int )1u))));
  if (((((unsigned char )(bool )(((((((unsigned char )(bool )(((signed int )llvm_cbe_tmp__16) > ((signed int )0u)))) != ((unsigned char )0)) ^ 1)&1)))) != ((unsigned char )0))) {
    goto llvm_cbe_bb5_2e_i6;
  } else {
    goto llvm_cbe_bb4_2e_i5;
  }

llvm_cbe_bb4_2e_i5:
  llvm_cbe_tmp__17 = *(&InCnt);
  *(&InCnt) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__17) - ((unsigned int )1u))));
  llvm_cbe_tmp__18 = *(&InBuff);
  llvm_cbe_tmp__19 = *llvm_cbe_tmp__18;
  *(&llvm_cbe_tmp__2) = (((unsigned int )(unsigned char )llvm_cbe_tmp__19));
  *(&InBuff) = ((&llvm_cbe_tmp__18[((signed long long )1ull)]));
  goto llvm_cbe_getbyte_2e_exit;

llvm_cbe_bb5_2e_i6:
  *(&llvm_cbe_tmp__2) = 4294967295u;
  goto llvm_cbe_getbyte_2e_exit;

llvm_cbe_getbyte_2e_exit:
  llvm_cbe_tmp__20 = *(&llvm_cbe_tmp__2);
  *(&llvm_cbe_retval_2e_i) = llvm_cbe_tmp__20;
  llvm_cbe_retval7_2e_i = *(&llvm_cbe_retval_2e_i);
  *(&llvm_cbe_ent_2e_i) = llvm_cbe_retval7_2e_i;
  *(&llvm_cbe_hshift_2e_i) = 0u;
  llvm_cbe_tmp__21 = *(&hsize);
  *(&llvm_cbe_fcode_2e_i) = llvm_cbe_tmp__21;
  goto llvm_cbe_bb4_2e_i;

  do {     /* Syntactic loop 'bb4.i' to make GCC happy */
llvm_cbe_bb4_2e_i:
  llvm_cbe_tmp__23 = *(&llvm_cbe_fcode_2e_i);
  llvm_cbe_tmp__24 = *(&llvm_cbe_hshift_2e_i);
  if ((((signed int )llvm_cbe_tmp__23) <= ((signed int )65535u))) {
    goto llvm_cbe_bb3_2e_i;
  } else {
    goto llvm_cbe_bb5_2e_i;
  }

llvm_cbe_bb3_2e_i:
  *(&llvm_cbe_hshift_2e_i) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__24) + ((unsigned int )1u))));
  llvm_cbe_tmp__22 = *(&llvm_cbe_fcode_2e_i);
  *(&llvm_cbe_fcode_2e_i) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__22) * ((unsigned int )2u))));
  goto llvm_cbe_bb4_2e_i;

  } while (1); /* end of syntactic loop 'bb4.i' */
llvm_cbe_bb5_2e_i:
  *(&llvm_cbe_hshift_2e_i) = (((unsigned int )(((unsigned int )8u) - ((unsigned int )llvm_cbe_tmp__24))));
  llvm_cbe_tmp__25 = *(&hsize);
  *(&llvm_cbe_hsize_reg_2e_i) = llvm_cbe_tmp__25;
  llvm_cbe_tmp__26 = *(&llvm_cbe_hsize_reg_2e_i);
  *(&llvm_cbe_hsize_addr_2e_i) = llvm_cbe_tmp__26;
  llvm_cbe_tmp__27 = *(&llvm_cbe_hsize_addr_2e_i);
  *(&llvm_cbe_htab_p_2e_i) = ((&((&htab.array[((signed int )0u)]))[((signed int )llvm_cbe_tmp__27)]));
  *(&llvm_cbe_m1_2e_i) = 4294967295u;
  llvm_cbe_tmp__28 = *(&llvm_cbe_hsize_addr_2e_i);
  *(&llvm_cbe_i_2e_i8) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__28) - ((unsigned int )16u))));
  goto llvm_cbe_bb_2e_i9;

  do {     /* Syntactic loop 'bb.i9' to make GCC happy */
llvm_cbe_bb_2e_i9:
  llvm_cbe_tmp__29 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__30 = *(&llvm_cbe_m1_2e_i);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__29[((signed int )4294967280u)])))->data = llvm_cbe_tmp__30;
  llvm_cbe_tmp__31 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__32 = *(&llvm_cbe_m1_2e_i);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__31[((signed int )4294967281u)])))->data = llvm_cbe_tmp__32;
  llvm_cbe_tmp__33 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__34 = *(&llvm_cbe_m1_2e_i);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__33[((signed int )4294967282u)])))->data = llvm_cbe_tmp__34;
  llvm_cbe_tmp__35 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__36 = *(&llvm_cbe_m1_2e_i);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__35[((signed int )4294967283u)])))->data = llvm_cbe_tmp__36;
  llvm_cbe_tmp__37 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__38 = *(&llvm_cbe_m1_2e_i);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__37[((signed int )4294967284u)])))->data = llvm_cbe_tmp__38;
  llvm_cbe_tmp__39 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__40 = *(&llvm_cbe_m1_2e_i);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__39[((signed int )4294967285u)])))->data = llvm_cbe_tmp__40;
  llvm_cbe_tmp__41 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__42 = *(&llvm_cbe_m1_2e_i);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__41[((signed int )4294967286u)])))->data = llvm_cbe_tmp__42;
  llvm_cbe_tmp__43 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__44 = *(&llvm_cbe_m1_2e_i);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__43[((signed int )4294967287u)])))->data = llvm_cbe_tmp__44;
  llvm_cbe_tmp__45 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__46 = *(&llvm_cbe_m1_2e_i);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__45[((signed int )4294967288u)])))->data = llvm_cbe_tmp__46;
  llvm_cbe_tmp__47 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__48 = *(&llvm_cbe_m1_2e_i);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__47[((signed int )4294967289u)])))->data = llvm_cbe_tmp__48;
  llvm_cbe_tmp__49 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__50 = *(&llvm_cbe_m1_2e_i);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__49[((signed int )4294967290u)])))->data = llvm_cbe_tmp__50;
  llvm_cbe_tmp__51 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__52 = *(&llvm_cbe_m1_2e_i);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__51[((signed int )4294967291u)])))->data = llvm_cbe_tmp__52;
  llvm_cbe_tmp__53 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__54 = *(&llvm_cbe_m1_2e_i);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__53[((signed int )4294967292u)])))->data = llvm_cbe_tmp__54;
  llvm_cbe_tmp__55 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__56 = *(&llvm_cbe_m1_2e_i);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__55[((signed int )4294967293u)])))->data = llvm_cbe_tmp__56;
  llvm_cbe_tmp__57 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__58 = *(&llvm_cbe_m1_2e_i);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__57[((signed int )4294967294u)])))->data = llvm_cbe_tmp__58;
  llvm_cbe_tmp__59 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__60 = *(&llvm_cbe_m1_2e_i);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__59[((signed int )4294967295u)])))->data = llvm_cbe_tmp__60;
  llvm_cbe_tmp__61 = *(&llvm_cbe_htab_p_2e_i);
  *(&llvm_cbe_htab_p_2e_i) = ((&llvm_cbe_tmp__61[((signed int )4294967280u)]));
  llvm_cbe_tmp__62 = *(&llvm_cbe_i_2e_i8);
  *(&llvm_cbe_i_2e_i8) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__62) - ((unsigned int )16u))));
  llvm_cbe_tmp__63 = *(&llvm_cbe_i_2e_i8);
  if ((((signed int )llvm_cbe_tmp__63) >= ((signed int )0u))) {
    goto llvm_cbe_bb_2e_i9;
  } else {
    goto llvm_cbe_bb1_2e_i10;
  }

  } while (1); /* end of syntactic loop 'bb.i9' */
llvm_cbe_bb1_2e_i10:
  llvm_cbe_tmp__64 = *(&llvm_cbe_i_2e_i8);
  *(&llvm_cbe_i_2e_i8) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__64) + ((unsigned int )16u))));
  goto llvm_cbe_bb3_2e_i12;

  do {     /* Syntactic loop 'bb3.i12' to make GCC happy */
llvm_cbe_bb3_2e_i12:
  llvm_cbe_tmp__69 = *(&llvm_cbe_i_2e_i8);
  if ((((signed int )llvm_cbe_tmp__69) > ((signed int )0u))) {
    goto llvm_cbe_bb2_2e_i11;
  } else {
    goto llvm_cbe_bb20_2e_i;
  }

llvm_cbe_bb2_2e_i11:
  llvm_cbe_tmp__65 = *(&llvm_cbe_htab_p_2e_i);
  *(&llvm_cbe_htab_p_2e_i) = ((&llvm_cbe_tmp__65[((signed long long )18446744073709551615ull)]));
  llvm_cbe_tmp__66 = *(&llvm_cbe_htab_p_2e_i);
  llvm_cbe_tmp__67 = *(&llvm_cbe_m1_2e_i);
  *llvm_cbe_tmp__66 = llvm_cbe_tmp__67;
  llvm_cbe_tmp__68 = *(&llvm_cbe_i_2e_i8);
  *(&llvm_cbe_i_2e_i8) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__68) - ((unsigned int )1u))));
  goto llvm_cbe_bb3_2e_i12;

  } while (1); /* end of syntactic loop 'bb3.i12' */
  do {     /* Syntactic loop 'bb20.i' to make GCC happy */
llvm_cbe_bb20_2e_i:
  llvm_cbe_tmp__250 = *(&InCnt);
  if ((((signed int )llvm_cbe_tmp__250) > ((signed int )0u))) {
    goto llvm_cbe_bb6_2e_i;
  } else {
    goto llvm_cbe_bb21_2e_i;
  }

llvm_cbe_bb7_2e_i:
  llvm_cbe_tmp__87 = *((&codetab.array[((signed int )llvm_cbe_tmp__86)]));
  *(&llvm_cbe_ent_2e_i) = (((unsigned int )(unsigned short )llvm_cbe_tmp__87));
  goto llvm_cbe_bb20_2e_i;

llvm_cbe_getbyte_2e_exit24:
  llvm_cbe_tmp__75 = *(&llvm_cbe_tmp__1);
  *(&llvm_cbe_retval_2e_i14) = llvm_cbe_tmp__75;
  llvm_cbe_retval7_2e_i23 = *(&llvm_cbe_retval_2e_i14);
  *(&llvm_cbe_c_2e_i) = llvm_cbe_retval7_2e_i23;
  llvm_cbe_tmp__76 = *(&in_count);
  *(&in_count) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__76) + ((unsigned int )1u))));
  llvm_cbe_tmp__77 = *(&maxbits);
  llvm_cbe_tmp__78 = *(&llvm_cbe_c_2e_i);
  llvm_cbe_tmp__79 = *(&llvm_cbe_ent_2e_i);
  *(&llvm_cbe_fcode_2e_i) = (((unsigned int )(((unsigned int )(llvm_cbe_tmp__78 << llvm_cbe_tmp__77)) + ((unsigned int )llvm_cbe_tmp__79))));
  llvm_cbe_tmp__80 = *(&llvm_cbe_c_2e_i);
  llvm_cbe_tmp__81 = *(&llvm_cbe_hshift_2e_i);
  llvm_cbe_tmp__82 = *(&llvm_cbe_ent_2e_i);
  *(&llvm_cbe_i_2e_i1) = ((llvm_cbe_tmp__80 << llvm_cbe_tmp__81) ^ llvm_cbe_tmp__82);
  llvm_cbe_tmp__83 = *(&llvm_cbe_i_2e_i1);
  llvm_cbe_tmp__84 = *((&htab.array[((signed int )llvm_cbe_tmp__83)]));
  llvm_cbe_tmp__85 = *(&llvm_cbe_fcode_2e_i);
  llvm_cbe_tmp__86 = *(&llvm_cbe_i_2e_i1);
  if ((llvm_cbe_tmp__84 == llvm_cbe_tmp__85)) {
    goto llvm_cbe_bb7_2e_i;
  } else {
    goto llvm_cbe_bb8_2e_i;
  }

llvm_cbe_bb4_2e_i20:
  llvm_cbe_tmp__72 = *(&InCnt);
  *(&InCnt) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__72) - ((unsigned int )1u))));
  llvm_cbe_tmp__73 = *(&InBuff);
  llvm_cbe_tmp__74 = *llvm_cbe_tmp__73;
  *(&llvm_cbe_tmp__1) = (((unsigned int )(unsigned char )llvm_cbe_tmp__74));
  *(&InBuff) = ((&llvm_cbe_tmp__73[((signed long long )1ull)]));
  goto llvm_cbe_getbyte_2e_exit24;

llvm_cbe_bb_2e_i19:
  llvm_cbe_tmp__71 = *(&apsim_InCnt);
  *(&apsim_InCnt) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__71) - ((unsigned int )1u))));
  if (((((unsigned char )(bool )(((((((unsigned char )(bool )(((signed int )llvm_cbe_tmp__71) > ((signed int )0u)))) != ((unsigned char )0)) ^ 1)&1)))) != ((unsigned char )0))) {
    goto llvm_cbe_bb5_2e_i21;
  } else {
    goto llvm_cbe_bb4_2e_i20;
  }

llvm_cbe_bb6_2e_i:
  *(&llvm_cbe_apsim_bound111_2e_i) = 0u;
  llvm_cbe_tmp__70 = *(&InCnt);
  if ((((signed int )llvm_cbe_tmp__70) <= ((signed int )0u))) {
    goto llvm_cbe_bb5_2e_i21;
  } else {
    goto llvm_cbe_bb_2e_i19;
  }

llvm_cbe_bb5_2e_i21:
  *(&llvm_cbe_tmp__1) = 4294967295u;
  goto llvm_cbe_getbyte_2e_exit24;

llvm_cbe_bb13_2e_i:
  llvm_cbe_tmp__101 = *((&codetab.array[((signed int )llvm_cbe_tmp__100)]));
  *(&llvm_cbe_ent_2e_i) = (((unsigned int )(unsigned short )llvm_cbe_tmp__101));
  goto llvm_cbe_bb20_2e_i;

  do {     /* Syntactic loop 'probe.i' to make GCC happy */
llvm_cbe_probe_2e_i:
  llvm_cbe_tmp__92 = *(&llvm_cbe_i_2e_i1);
  llvm_cbe_tmp__93 = *(&llvm_cbe_disp_2e_i);
  *(&llvm_cbe_i_2e_i1) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__92) - ((unsigned int )llvm_cbe_tmp__93))));
  llvm_cbe_tmp__94 = *(&llvm_cbe_i_2e_i1);
  if ((((signed int )llvm_cbe_tmp__94) < ((signed int )0u))) {
    goto llvm_cbe_bb11_2e_i;
  } else {
    goto llvm_cbe_bb12_2e_i;
  }

llvm_cbe_bb15_2e_i:
  llvm_cbe_tmp__103 = *(&llvm_cbe_apsim_bound111_2e_i);
  *(&llvm_cbe_apsim_bound111_2e_i) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__103) + ((unsigned int )1u))));
  llvm_cbe_tmp__104 = *(&in_count);
  llvm_cbe_tmp__105 = *(&llvm_cbe_apsim_bound111_2e_i);
  if ((((signed int )llvm_cbe_tmp__105) < ((signed int )llvm_cbe_tmp__104))) {
    goto llvm_cbe_probe_2e_i;
  } else {
    goto llvm_cbe_nomatch_2e_i;
  }

llvm_cbe_bb14_2e_i:
  llvm_cbe_tmp__102 = *((&htab.array[((signed int )llvm_cbe_tmp__100)]));
  if ((((signed int )llvm_cbe_tmp__102) > ((signed int )0u))) {
    goto llvm_cbe_bb15_2e_i;
  } else {
    goto llvm_cbe_nomatch_2e_i;
  }

llvm_cbe_bb12_2e_i:
  llvm_cbe_tmp__97 = *(&llvm_cbe_i_2e_i1);
  llvm_cbe_tmp__98 = *((&htab.array[((signed int )llvm_cbe_tmp__97)]));
  llvm_cbe_tmp__99 = *(&llvm_cbe_fcode_2e_i);
  llvm_cbe_tmp__100 = *(&llvm_cbe_i_2e_i1);
  if ((llvm_cbe_tmp__98 == llvm_cbe_tmp__99)) {
    goto llvm_cbe_bb13_2e_i;
  } else {
    goto llvm_cbe_bb14_2e_i;
  }

llvm_cbe_bb11_2e_i:
  llvm_cbe_tmp__95 = *(&llvm_cbe_i_2e_i1);
  llvm_cbe_tmp__96 = *(&llvm_cbe_hsize_reg_2e_i);
  *(&llvm_cbe_i_2e_i1) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__95) + ((unsigned int )llvm_cbe_tmp__96))));
  goto llvm_cbe_bb12_2e_i;

  } while (1); /* end of syntactic loop 'probe.i' */
llvm_cbe_bb9_2e_i:
  llvm_cbe_tmp__89 = *(&llvm_cbe_hsize_reg_2e_i);
  llvm_cbe_tmp__90 = *(&llvm_cbe_i_2e_i1);
  *(&llvm_cbe_disp_2e_i) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__89) - ((unsigned int )llvm_cbe_tmp__90))));
  llvm_cbe_tmp__91 = *(&llvm_cbe_i_2e_i1);
  if ((llvm_cbe_tmp__91 == 0u)) {
    goto llvm_cbe_bb10_2e_i;
  } else {
    goto llvm_cbe_probe_2e_i;
  }

llvm_cbe_bb8_2e_i:
  llvm_cbe_tmp__88 = *((&htab.array[((signed int )llvm_cbe_tmp__86)]));
  if ((((signed int )llvm_cbe_tmp__88) < ((signed int )0u))) {
    goto llvm_cbe_nomatch_2e_i;
  } else {
    goto llvm_cbe_bb9_2e_i;
  }

llvm_cbe_bb10_2e_i:
  *(&llvm_cbe_disp_2e_i) = 1u;
  goto llvm_cbe_probe_2e_i;

llvm_cbe_bb16_2e_i:
  llvm_cbe_tmp__110 = *(&llvm_cbe_i_2e_i1);
  llvm_cbe_tmp__111 = *(&free_ent);
  *((&codetab.array[((signed int )llvm_cbe_tmp__110)])) = (((unsigned short )llvm_cbe_tmp__111));
  *(&free_ent) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__111) + ((unsigned int )1u))));
  llvm_cbe_tmp__112 = *(&llvm_cbe_i_2e_i1);
  llvm_cbe_tmp__113 = *(&llvm_cbe_fcode_2e_i);
  *((&htab.array[((signed int )llvm_cbe_tmp__112)])) = llvm_cbe_tmp__113;
  goto llvm_cbe_bb20_2e_i;

llvm_cbe_nomatch_2e_i:
  llvm_cbe_tmp__106 = *(&out_count);
  *(&out_count) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__106) + ((unsigned int )1u))));
  llvm_cbe_tmp__107 = *(&llvm_cbe_c_2e_i);
  *(&llvm_cbe_ent_2e_i) = llvm_cbe_tmp__107;
  llvm_cbe_tmp__108 = *(&free_ent);
  llvm_cbe_tmp__109 = *(&maxmaxcode);
  if ((((signed int )llvm_cbe_tmp__108) < ((signed int )llvm_cbe_tmp__109))) {
    goto llvm_cbe_bb16_2e_i;
  } else {
    goto llvm_cbe_bb17_2e_i;
  }

llvm_cbe_bb17_2e_i:
  llvm_cbe_tmp__114 = *(&in_count);
  llvm_cbe_tmp__115 = *(&checkpoint);
  llvm_cbe_tmp__116 = *(&block_compress);
  if (((((((signed int )llvm_cbe_tmp__114) >= ((signed int )llvm_cbe_tmp__115)) & (llvm_cbe_tmp__116 != 0u))&1))) {
    goto llvm_cbe_bb19_2e_i;
  } else {
    goto llvm_cbe_bb20_2e_i;
  }

llvm_cbe_bb21_2e_i65:
  llvm_cbe_tmp__248 = *(&offset);
  llvm_cbe_tmp__249 = *(&bytes_out);
  *(&bytes_out) = (((unsigned int )(((unsigned int )(((signed int )(((signed int )(((unsigned int )(((unsigned int )llvm_cbe_tmp__248) + ((unsigned int )7u))))) / ((signed int )8u))))) + ((unsigned int )llvm_cbe_tmp__249))));
  *(&offset) = 0u;
  goto llvm_cbe_bb20_2e_i;

llvm_cbe_bb19_2e_i63:
  llvm_cbe_tmp__238 = *(&offset);
  if ((((signed int )llvm_cbe_tmp__238) > ((signed int )0u))) {
    goto llvm_cbe_bb20_2e_i64;
  } else {
    goto llvm_cbe_bb21_2e_i65;
  }

llvm_cbe_cl_hash_2e_exit43:
  *(&free_ent) = 257u;
  *(&clear_flg) = 1u;
  *(&llvm_cbe_code_addr_2e_i) = 256u;
  llvm_cbe_tmp__172 = *(&offset);
  *(&llvm_cbe_r_off_2e_i) = llvm_cbe_tmp__172;
  llvm_cbe_tmp__173 = *(&n_bits);
  *(&llvm_cbe_bits_2e_i) = llvm_cbe_tmp__173;
  *(&llvm_cbe_bp_2e_i) = ((&buf.array[((signed int )0u)]));
  llvm_cbe_tmp__174 = *(&llvm_cbe_code_addr_2e_i);
  if ((((signed int )llvm_cbe_tmp__174) >= ((signed int )0u))) {
    goto llvm_cbe_bb_2e_i44;
  } else {
    goto llvm_cbe_bb19_2e_i63;
  }

  do {     /* Syntactic loop 'bb3.i41' to make GCC happy */
llvm_cbe_bb3_2e_i41:
  llvm_cbe_tmp__171 = *(&llvm_cbe_i_2e_i36);
  if ((((signed int )llvm_cbe_tmp__171) > ((signed int )0u))) {
    goto llvm_cbe_bb2_2e_i40;
  } else {
    goto llvm_cbe_cl_hash_2e_exit43;
  }

llvm_cbe_bb2_2e_i40:
  llvm_cbe_tmp__167 = *(&llvm_cbe_htab_p_2e_i35);
  *(&llvm_cbe_htab_p_2e_i35) = ((&llvm_cbe_tmp__167[((signed long long )18446744073709551615ull)]));
  llvm_cbe_tmp__168 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__169 = *(&llvm_cbe_m1_2e_i37);
  *llvm_cbe_tmp__168 = llvm_cbe_tmp__169;
  llvm_cbe_tmp__170 = *(&llvm_cbe_i_2e_i36);
  *(&llvm_cbe_i_2e_i36) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__170) - ((unsigned int )1u))));
  goto llvm_cbe_bb3_2e_i41;

  } while (1); /* end of syntactic loop 'bb3.i41' */
llvm_cbe_bb1_2e_i39:
  llvm_cbe_tmp__166 = *(&llvm_cbe_i_2e_i36);
  *(&llvm_cbe_i_2e_i36) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__166) + ((unsigned int )16u))));
  goto llvm_cbe_bb3_2e_i41;

  do {     /* Syntactic loop 'bb.i38' to make GCC happy */
llvm_cbe_bb_2e_i38:
  llvm_cbe_tmp__131 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__132 = *(&llvm_cbe_m1_2e_i37);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__131[((signed int )4294967280u)])))->data = llvm_cbe_tmp__132;
  llvm_cbe_tmp__133 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__134 = *(&llvm_cbe_m1_2e_i37);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__133[((signed int )4294967281u)])))->data = llvm_cbe_tmp__134;
  llvm_cbe_tmp__135 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__136 = *(&llvm_cbe_m1_2e_i37);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__135[((signed int )4294967282u)])))->data = llvm_cbe_tmp__136;
  llvm_cbe_tmp__137 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__138 = *(&llvm_cbe_m1_2e_i37);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__137[((signed int )4294967283u)])))->data = llvm_cbe_tmp__138;
  llvm_cbe_tmp__139 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__140 = *(&llvm_cbe_m1_2e_i37);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__139[((signed int )4294967284u)])))->data = llvm_cbe_tmp__140;
  llvm_cbe_tmp__141 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__142 = *(&llvm_cbe_m1_2e_i37);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__141[((signed int )4294967285u)])))->data = llvm_cbe_tmp__142;
  llvm_cbe_tmp__143 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__144 = *(&llvm_cbe_m1_2e_i37);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__143[((signed int )4294967286u)])))->data = llvm_cbe_tmp__144;
  llvm_cbe_tmp__145 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__146 = *(&llvm_cbe_m1_2e_i37);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__145[((signed int )4294967287u)])))->data = llvm_cbe_tmp__146;
  llvm_cbe_tmp__147 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__148 = *(&llvm_cbe_m1_2e_i37);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__147[((signed int )4294967288u)])))->data = llvm_cbe_tmp__148;
  llvm_cbe_tmp__149 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__150 = *(&llvm_cbe_m1_2e_i37);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__149[((signed int )4294967289u)])))->data = llvm_cbe_tmp__150;
  llvm_cbe_tmp__151 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__152 = *(&llvm_cbe_m1_2e_i37);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__151[((signed int )4294967290u)])))->data = llvm_cbe_tmp__152;
  llvm_cbe_tmp__153 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__154 = *(&llvm_cbe_m1_2e_i37);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__153[((signed int )4294967291u)])))->data = llvm_cbe_tmp__154;
  llvm_cbe_tmp__155 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__156 = *(&llvm_cbe_m1_2e_i37);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__155[((signed int )4294967292u)])))->data = llvm_cbe_tmp__156;
  llvm_cbe_tmp__157 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__158 = *(&llvm_cbe_m1_2e_i37);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__157[((signed int )4294967293u)])))->data = llvm_cbe_tmp__158;
  llvm_cbe_tmp__159 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__160 = *(&llvm_cbe_m1_2e_i37);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__159[((signed int )4294967294u)])))->data = llvm_cbe_tmp__160;
  llvm_cbe_tmp__161 = *(&llvm_cbe_htab_p_2e_i35);
  llvm_cbe_tmp__162 = *(&llvm_cbe_m1_2e_i37);
  ((struct __attribute__ ((packed, aligned(1))) {unsigned int data; } *)((&llvm_cbe_tmp__161[((signed int )4294967295u)])))->data = llvm_cbe_tmp__162;
  llvm_cbe_tmp__163 = *(&llvm_cbe_htab_p_2e_i35);
  *(&llvm_cbe_htab_p_2e_i35) = ((&llvm_cbe_tmp__163[((signed int )4294967280u)]));
  llvm_cbe_tmp__164 = *(&llvm_cbe_i_2e_i36);
  *(&llvm_cbe_i_2e_i36) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__164) - ((unsigned int )16u))));
  llvm_cbe_tmp__165 = *(&llvm_cbe_i_2e_i36);
  if ((((signed int )llvm_cbe_tmp__165) >= ((signed int )0u))) {
    goto llvm_cbe_bb_2e_i38;
  } else {
    goto llvm_cbe_bb1_2e_i39;
  }

  } while (1); /* end of syntactic loop 'bb.i38' */
llvm_cbe_bb7_2e_i32:
  *(&ratio) = 0u;
  llvm_cbe_tmp__128 = *(&hsize);
  *(&llvm_cbe_hsize_addr_2e_i34) = llvm_cbe_tmp__128;
  llvm_cbe_tmp__129 = *(&llvm_cbe_hsize_addr_2e_i34);
  *(&llvm_cbe_htab_p_2e_i35) = ((&((&htab.array[((signed int )0u)]))[((signed int )llvm_cbe_tmp__129)]));
  *(&llvm_cbe_m1_2e_i37) = 4294967295u;
  llvm_cbe_tmp__130 = *(&llvm_cbe_hsize_addr_2e_i34);
  *(&llvm_cbe_i_2e_i36) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__130) - ((unsigned int )16u))));
  goto llvm_cbe_bb_2e_i38;

llvm_cbe_bb5_2e_i30:
  llvm_cbe_tmp__125 = *(&ratio);
  llvm_cbe_tmp__126 = *(&llvm_cbe_rat_2e_i);
  if ((((signed int )llvm_cbe_tmp__126) > ((signed int )llvm_cbe_tmp__125))) {
    goto llvm_cbe_bb6_2e_i31;
  } else {
    goto llvm_cbe_bb7_2e_i32;
  }

llvm_cbe_bb4_2e_i29:
  llvm_cbe_tmp__123 = *(&in_count);
  llvm_cbe_tmp__124 = *(&bytes_out);
  *(&llvm_cbe_rat_2e_i) = (((signed int )(((signed int )(llvm_cbe_tmp__123 << 8u)) / ((signed int )llvm_cbe_tmp__124))));
  goto llvm_cbe_bb5_2e_i30;

llvm_cbe_bb19_2e_i:
  llvm_cbe_tmp__117 = *(&in_count);
  *(&checkpoint) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__117) + ((unsigned int )10000u))));
  llvm_cbe_tmp__118 = *(&in_count);
  if ((((signed int )llvm_cbe_tmp__118) > ((signed int )8388607u))) {
    goto llvm_cbe_bb_2e_i25;
  } else {
    goto llvm_cbe_bb4_2e_i29;
  }

llvm_cbe_bb2_2e_i27:
  llvm_cbe_tmp__121 = *(&in_count);
  llvm_cbe_tmp__122 = *(&llvm_cbe_rat_2e_i);
  *(&llvm_cbe_rat_2e_i) = (((signed int )(((signed int )llvm_cbe_tmp__121) / ((signed int )llvm_cbe_tmp__122))));
  goto llvm_cbe_bb5_2e_i30;

llvm_cbe_bb_2e_i25:
  llvm_cbe_tmp__119 = *(&bytes_out);
  *(&llvm_cbe_rat_2e_i) = (((signed int )(((signed int )llvm_cbe_tmp__119) >> ((signed int )8u))));
  llvm_cbe_tmp__120 = *(&llvm_cbe_rat_2e_i);
  if ((llvm_cbe_tmp__120 == 0u)) {
    goto llvm_cbe_bb1_2e_i26;
  } else {
    goto llvm_cbe_bb2_2e_i27;
  }

llvm_cbe_bb1_2e_i26:
  *(&llvm_cbe_rat_2e_i) = 2147483647u;
  goto llvm_cbe_bb5_2e_i30;

  do {     /* Syntactic loop 'bb1.i76' to make GCC happy */
llvm_cbe_bb1_2e_i76:
  llvm_cbe_tmp__245 = *(&llvm_cbe_i_2e_i74);
  llvm_cbe_tmp__246 = *(&llvm_cbe_n_addr_2e_i73);
  llvm_cbe_tmp__247 = *(&llvm_cbe_i_2e_i74);
  if ((((((((((signed int )llvm_cbe_tmp__245) >= ((signed int )llvm_cbe_tmp__246)) ^ 1)&1)) & (((signed int )llvm_cbe_tmp__247) <= ((signed int )15u)))&1))) {
    goto llvm_cbe_bb_2e_i75;
  } else {
    goto llvm_cbe_bb21_2e_i65;
  }

llvm_cbe_bb_2e_i75:
  llvm_cbe_tmp__240 = *(&OutBuff);
  llvm_cbe_tmp__241 = *(&llvm_cbe_buf_addr_2e_i72);
  llvm_cbe_tmp__242 = *(&llvm_cbe_i_2e_i74);
  llvm_cbe_tmp__243 = *((&llvm_cbe_tmp__241[((signed int )llvm_cbe_tmp__242)]));
  *llvm_cbe_tmp__240 = llvm_cbe_tmp__243;
  *(&OutBuff) = ((&llvm_cbe_tmp__240[((signed long long )1ull)]));
  llvm_cbe_tmp__244 = *(&llvm_cbe_i_2e_i74);
  *(&llvm_cbe_i_2e_i74) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__244) + ((unsigned int )1u))));
  goto llvm_cbe_bb1_2e_i76;

  } while (1); /* end of syntactic loop 'bb1.i76' */
llvm_cbe_bb20_2e_i64:
  llvm_cbe_tmp__239 = *(&offset);
  *(&llvm_cbe_buf_addr_2e_i72) = ((&buf.array[((signed int )0u)]));
  *(&llvm_cbe_n_addr_2e_i73) = (((signed int )(((signed int )(((unsigned int )(((unsigned int )llvm_cbe_tmp__239) + ((unsigned int )7u))))) / ((signed int )8u))));
  *(&llvm_cbe_i_2e_i74) = 0u;
  goto llvm_cbe_bb1_2e_i76;

llvm_cbe_bb9_2e_i53:
  llvm_cbe_tmp__216 = *(&free_ent);
  llvm_cbe_tmp__217 = *(&maxcode);
  llvm_cbe_tmp__218 = *(&clear_flg);
  if (((((((signed int )llvm_cbe_tmp__216) > ((signed int )llvm_cbe_tmp__217)) | (((signed int )llvm_cbe_tmp__218) > ((signed int )0u)))&1))) {
    goto llvm_cbe_bb11_2e_i55;
  } else {
    goto llvm_cbe_bb20_2e_i;
  }

llvm_cbe_bb4_2e_i48:
  llvm_cbe_tmp__201 = *(&offset);
  llvm_cbe_tmp__202 = *(&n_bits);
  *(&offset) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__201) + ((unsigned int )llvm_cbe_tmp__202))));
  llvm_cbe_tmp__203 = *(&n_bits);
  llvm_cbe_tmp__204 = *(&offset);
  if (((llvm_cbe_tmp__203 << 3u) == llvm_cbe_tmp__204)) {
    goto llvm_cbe_bb5_2e_i49;
  } else {
    goto llvm_cbe_bb9_2e_i53;
  }

llvm_cbe_bb2_2e_i46:
  llvm_cbe_tmp__198 = *(&llvm_cbe_bits_2e_i);
  if ((llvm_cbe_tmp__198 != 0u)) {
    goto llvm_cbe_bb3_2e_i47;
  } else {
    goto llvm_cbe_bb4_2e_i48;
  }

llvm_cbe_bb_2e_i44:
  llvm_cbe_tmp__175 = *(&llvm_cbe_r_off_2e_i);
  llvm_cbe_tmp__176 = *(&llvm_cbe_bp_2e_i);
  *(&llvm_cbe_bp_2e_i) = ((&llvm_cbe_tmp__176[((signed int )(((signed int )(((signed int )llvm_cbe_tmp__175) >> ((signed int )3u)))))]));
  llvm_cbe_tmp__177 = *(&llvm_cbe_r_off_2e_i);
  *(&llvm_cbe_r_off_2e_i) = (llvm_cbe_tmp__177 & 7u);
  llvm_cbe_tmp__178 = *(&llvm_cbe_bp_2e_i);
  llvm_cbe_tmp__179 = *llvm_cbe_tmp__178;
  llvm_cbe_tmp__180 = *(&llvm_cbe_r_off_2e_i);
  llvm_cbe_tmp__181 = *((&rmask.array[((signed int )llvm_cbe_tmp__180)]));
  llvm_cbe_tmp__182 = *(&llvm_cbe_code_addr_2e_i);
  llvm_cbe_tmp__183 = *(&llvm_cbe_r_off_2e_i);
  llvm_cbe_tmp__184 = *(&llvm_cbe_r_off_2e_i);
  llvm_cbe_tmp__185 = *((&lmask.array[((signed int )llvm_cbe_tmp__184)]));
  llvm_cbe_tmp__186 = *(&llvm_cbe_bp_2e_i);
  *llvm_cbe_tmp__186 = (((unsigned char )((((unsigned char )((((unsigned char )(llvm_cbe_tmp__179 & llvm_cbe_tmp__181))) | (((unsigned char )(llvm_cbe_tmp__182 << llvm_cbe_tmp__183)))))) & llvm_cbe_tmp__185)));
  llvm_cbe_tmp__187 = *(&llvm_cbe_bp_2e_i);
  *(&llvm_cbe_bp_2e_i) = ((&llvm_cbe_tmp__187[((signed long long )1ull)]));
  llvm_cbe_tmp__188 = *(&llvm_cbe_r_off_2e_i);
  llvm_cbe_tmp__189 = *(&llvm_cbe_bits_2e_i);
  *(&llvm_cbe_bits_2e_i) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__189) - ((unsigned int )(((unsigned int )(((unsigned int )8u) - ((unsigned int )llvm_cbe_tmp__188))))))));
  llvm_cbe_tmp__190 = *(&llvm_cbe_r_off_2e_i);
  llvm_cbe_tmp__191 = *(&llvm_cbe_code_addr_2e_i);
  *(&llvm_cbe_code_addr_2e_i) = (((signed int )(((signed int )llvm_cbe_tmp__191) >> ((signed int )(((unsigned int )(((unsigned int )8u) - ((unsigned int )llvm_cbe_tmp__190))))))));
  llvm_cbe_tmp__192 = *(&llvm_cbe_bits_2e_i);
  if ((((signed int )llvm_cbe_tmp__192) > ((signed int )7u))) {
    goto llvm_cbe_bb1_2e_i45;
  } else {
    goto llvm_cbe_bb2_2e_i46;
  }

llvm_cbe_bb1_2e_i45:
  llvm_cbe_tmp__193 = *(&llvm_cbe_code_addr_2e_i);
  llvm_cbe_tmp__194 = *(&llvm_cbe_bp_2e_i);
  *llvm_cbe_tmp__194 = (((unsigned char )llvm_cbe_tmp__193));
  llvm_cbe_tmp__195 = *(&llvm_cbe_bp_2e_i);
  *(&llvm_cbe_bp_2e_i) = ((&llvm_cbe_tmp__195[((signed long long )1ull)]));
  llvm_cbe_tmp__196 = *(&llvm_cbe_code_addr_2e_i);
  *(&llvm_cbe_code_addr_2e_i) = (((signed int )(((signed int )llvm_cbe_tmp__196) >> ((signed int )8u))));
  llvm_cbe_tmp__197 = *(&llvm_cbe_bits_2e_i);
  *(&llvm_cbe_bits_2e_i) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__197) - ((unsigned int )8u))));
  goto llvm_cbe_bb2_2e_i46;

llvm_cbe_bb3_2e_i47:
  llvm_cbe_tmp__199 = *(&llvm_cbe_code_addr_2e_i);
  llvm_cbe_tmp__200 = *(&llvm_cbe_bp_2e_i);
  *llvm_cbe_tmp__200 = (((unsigned char )llvm_cbe_tmp__199));
  goto llvm_cbe_bb4_2e_i48;

llvm_cbe_bb8_2e_i52:
  *(&offset) = 0u;
  goto llvm_cbe_bb9_2e_i53;

  do {     /* Syntactic loop 'bb6.i50' to make GCC happy */
llvm_cbe_bb6_2e_i50:
  llvm_cbe_tmp__208 = *(&llvm_cbe_bp_2e_i);
  llvm_cbe_tmp__209 = *llvm_cbe_tmp__208;
  llvm_cbe_tmp__210 = *(&llvm_cbe_bp_2e_i);
  *(&llvm_cbe_bp_2e_i) = ((&llvm_cbe_tmp__210[((signed long long )1ull)]));
  *(&llvm_cbe_c_addr_2e_i) = (((unsigned char )(((signed int )(signed char )llvm_cbe_tmp__209))));
  llvm_cbe_tmp__211 = *(&OutBuff);
  llvm_cbe_tmp__212 = *(&llvm_cbe_c_addr_2e_i);
  *llvm_cbe_tmp__211 = llvm_cbe_tmp__212;
  *(&OutBuff) = ((&llvm_cbe_tmp__211[((signed long long )1ull)]));
  llvm_cbe_tmp__213 = *(&llvm_cbe_bits_2e_i);
  *(&llvm_cbe_bits_2e_i) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__213) - ((unsigned int )1u))));
  llvm_cbe_tmp__214 = *(&llvm_cbe_bits_2e_i);
  if ((llvm_cbe_tmp__214 == 0u)) {
    goto llvm_cbe_bb8_2e_i52;
  } else {
    goto llvm_cbe_bb7_2e_i51;
  }

llvm_cbe_bb7_2e_i51:
  llvm_cbe_tmp__215 = *(&llvm_cbe_bp_2e_i);
  if ((((signed int )(((unsigned int )(((unsigned int )(((unsigned int )(unsigned long)llvm_cbe_tmp__215))) - ((unsigned int )((unsigned int )(unsigned long)(&buf))))))) <= ((signed int )15u))) {
    goto llvm_cbe_bb6_2e_i50;
  } else {
    goto llvm_cbe_bb8_2e_i52;
  }

  } while (1); /* end of syntactic loop 'bb6.i50' */
llvm_cbe_bb5_2e_i49:
  *(&llvm_cbe_bp_2e_i) = ((&buf.array[((signed int )0u)]));
  llvm_cbe_tmp__205 = *(&n_bits);
  *(&llvm_cbe_bits_2e_i) = llvm_cbe_tmp__205;
  llvm_cbe_tmp__206 = *(&bytes_out);
  llvm_cbe_tmp__207 = *(&llvm_cbe_bits_2e_i);
  *(&bytes_out) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__206) + ((unsigned int )llvm_cbe_tmp__207))));
  goto llvm_cbe_bb6_2e_i50;

llvm_cbe_bb17_2e_i61:
  llvm_cbe_tmp__237 = *(&n_bits);
  *(&maxcode) = (((unsigned int )(((unsigned int )(1u << llvm_cbe_tmp__237)) - ((unsigned int )1u))));
  goto llvm_cbe_bb20_2e_i;

llvm_cbe_bb15_2e_i59:
  llvm_cbe_tmp__233 = *(&n_bits);
  *(&n_bits) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__233) + ((unsigned int )1u))));
  llvm_cbe_tmp__234 = *(&n_bits);
  llvm_cbe_tmp__235 = *(&maxbits);
  if ((llvm_cbe_tmp__234 == llvm_cbe_tmp__235)) {
    goto llvm_cbe_bb16_2e_i60;
  } else {
    goto llvm_cbe_bb17_2e_i61;
  }

llvm_cbe_bb13_2e_i57:
  *(&offset) = 0u;
  llvm_cbe_tmp__231 = *(&clear_flg);
  if ((llvm_cbe_tmp__231 != 0u)) {
    goto llvm_cbe_bb14_2e_i58;
  } else {
    goto llvm_cbe_bb15_2e_i59;
  }

llvm_cbe_bb11_2e_i55:
  llvm_cbe_tmp__219 = *(&offset);
  if ((((signed int )llvm_cbe_tmp__219) > ((signed int )0u))) {
    goto llvm_cbe_bb12_2e_i56;
  } else {
    goto llvm_cbe_bb13_2e_i57;
  }

llvm_cbe_writebytes_2e_exit:
  llvm_cbe_tmp__229 = *(&bytes_out);
  llvm_cbe_tmp__230 = *(&n_bits);
  *(&bytes_out) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__229) + ((unsigned int )llvm_cbe_tmp__230))));
  goto llvm_cbe_bb13_2e_i57;

  do {     /* Syntactic loop 'bb1.i69' to make GCC happy */
llvm_cbe_bb1_2e_i69:
  llvm_cbe_tmp__226 = *(&llvm_cbe_i_2e_i67);
  llvm_cbe_tmp__227 = *(&llvm_cbe_n_addr_2e_i);
  llvm_cbe_tmp__228 = *(&llvm_cbe_i_2e_i67);
  if ((((((((((signed int )llvm_cbe_tmp__226) >= ((signed int )llvm_cbe_tmp__227)) ^ 1)&1)) & (((signed int )llvm_cbe_tmp__228) <= ((signed int )15u)))&1))) {
    goto llvm_cbe_bb_2e_i68;
  } else {
    goto llvm_cbe_writebytes_2e_exit;
  }

llvm_cbe_bb_2e_i68:
  llvm_cbe_tmp__221 = *(&OutBuff);
  llvm_cbe_tmp__222 = *(&llvm_cbe_buf_addr_2e_i);
  llvm_cbe_tmp__223 = *(&llvm_cbe_i_2e_i67);
  llvm_cbe_tmp__224 = *((&llvm_cbe_tmp__222[((signed int )llvm_cbe_tmp__223)]));
  *llvm_cbe_tmp__221 = llvm_cbe_tmp__224;
  *(&OutBuff) = ((&llvm_cbe_tmp__221[((signed long long )1ull)]));
  llvm_cbe_tmp__225 = *(&llvm_cbe_i_2e_i67);
  *(&llvm_cbe_i_2e_i67) = (((unsigned int )(((unsigned int )llvm_cbe_tmp__225) + ((unsigned int )1u))));
  goto llvm_cbe_bb1_2e_i69;

  } while (1); /* end of syntactic loop 'bb1.i69' */
llvm_cbe_bb12_2e_i56:
  llvm_cbe_tmp__220 = *(&n_bits);
  *(&llvm_cbe_buf_addr_2e_i) = ((&buf.array[((signed int )0u)]));
  *(&llvm_cbe_n_addr_2e_i) = llvm_cbe_tmp__220;
  *(&llvm_cbe_i_2e_i67) = 0u;
  goto llvm_cbe_bb1_2e_i69;

llvm_cbe_bb16_2e_i60:
  llvm_cbe_tmp__236 = *(&maxmaxcode);
  *(&maxcode) = llvm_cbe_tmp__236;
  goto llvm_cbe_bb20_2e_i;

llvm_cbe_bb14_2e_i58:
  *(&n_bits) = 9u;
  llvm_cbe_tmp__232 = *(&n_bits);
  *(&maxcode) = (((unsigned int )(((unsigned int )(1u << llvm_cbe_tmp__232)) - ((unsigned int )1u))));
  *(&clear_flg) = 0u;
  goto llvm_cbe_bb20_2e_i;

llvm_cbe_bb6_2e_i31:
  llvm_cbe_tmp__127 = *(&llvm_cbe_rat_2e_i);
  *(&ratio) = llvm_cbe_tmp__127;
  goto llvm_cbe_bb20_2e_i;

  } while (1); /* end of syntactic loop 'bb20.i' */
llvm_cbe_bb21_2e_i:
  llvm_cbe_tmp__251 = *(&bytes_out);
  llvm_cbe_tmp__252 = *(&in_count);
  if ((((signed int )llvm_cbe_tmp__251) > ((signed int )llvm_cbe_tmp__252))) {
    goto llvm_cbe_bb22_2e_i;
  } else {
    goto llvm_cbe_compress_2e_exit;
  }

llvm_cbe_bb22_2e_i:
  *(&exit_stat) = 2u;
  goto llvm_cbe_compress_2e_exit;

llvm_cbe_compress_2e_exit:
  *(&llvm_cbe_tmp__3) = 0u;
  llvm_cbe_tmp__253 = *(&llvm_cbe_tmp__3);
  *(&llvm_cbe_retval) = llvm_cbe_tmp__253;
  llvm_cbe_retval1 = *(&llvm_cbe_retval);
  return llvm_cbe_retval1;
}

