
#include "rtos.h"

extern unsigned high_water;

void register_task(const char * name,
                void * function, unsigned block_info_word,
                unsigned offset, unsigned period) 
{
    print("capture task\n");
    print(name);
    notify_task_name(name, function);
    call_function(function, 0);
}

void kernel_start(void) 
{
    print("capture complete\n");
    exit(0);
}

void _open(void * base, unsigned block_number, unsigned num_blocks)
{
    unsigned limit = block_number + num_blocks;

    if (num_blocks == 0) {
        print("num_blocks == 0 for open\n");
        exit(1);
    }
    if (limit > NUM_BLOCKS) {
        print("limit > NUM_BLOCKS for open\n");
        exit(1);
    }
    if (limit > high_water) {
        high_water = limit;
    }
}


